#include <QApplication>
#include <QMainWindow>
#include <QMenu>
#include <QMenuBar>
#include <QLabel>
#include <QAction>
#include <QContextMenuEvent>
#include <QScopedPointer>

class ContextMenuWidget : public QLabel
{
public:
    ContextMenuWidget(QWidget *parent = 0);

protected:
    void contextMenuEvent(QContextMenuEvent *);

private:
    QAction *m_a1;
    QAction *m_a2;
};

ContextMenuWidget::ContextMenuWidget(QWidget *parent)
    : QLabel(parent)
    , m_a1(new QAction("Test1", this))
    , m_a2(new QAction("Test2", this))
{
    setText("Right click, invoke action several times");
}

void ContextMenuWidget::contextMenuEvent(QContextMenuEvent *e)
{
    new bool; // some action on the allocator
    QScopedPointer<QMenu> menu( new QMenu);
    menu->addAction(m_a1);
    menu->addAction(m_a2);
    menu->exec(e->globalPos());
    e->accept();
}

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    QMainWindow w;    
    w.setWindowTitle(QT_VERSION_STR);
    w.setCentralWidget(new ContextMenuWidget);
    w.show();
    return a.exec();
}


